<?php

/**
 * $Id: payrbk.php 7290 2011-08-17 11:48:47Z shitz $
 * $LastChangedDate: 2011-08-17 17:48:47 +0600 (Ср, 17 авг 2011) $
 * $LastChangedBy: shitz $
 * MightyInvoice by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die('Restricted access');

class plgPaymentPayrbk extends JPlugin 
{
	function plgPaymentPayrbk(& $subject, $config) 
	{
		parent :: __construct($subject, $config);
	}
		
	function onReceivePayment(&$post) 
	{
		global $mainframe;
		
		if($mainframe->isAdmin()) return;
		if($post['processor'] != 'payrbk')
		{
			return 0;
		}
    	$default = $this->params;
		$params = new JParameter($post['params']);
		$secret = $params->get($post['processor']."_secret",$default->get($post['processor']."_secret"));
			
		$order['price'] 	= $post['recipientAmount'];
    	$order['sid'] 		= $post['orderId'];
    	$order['user_id'] 	= $post['userField_2'];
    	$order['gateway'] 	= $post['processor'];
    	$order['gateway_id'] = $post['invoiceId'];
		if(strtoupper($post['hash']) == strtoupper(
				md5(
					$post['eshopId']."::".$post['orderId']."::".$post['serviceName']."::".$post['eshopAccount']."::".$post['recipientAmount']
					."::".$post['recipientCurrency']."::".$post['paymentStatus']."::".$post['userName']."::".$post['userEmail']."::"
					.urldecode($post['paymentData'])."::".$secret
						)
				)
				 && $post['paymentStatus'] == 5)
		{
			$db = JFactory::getDBO();
			$sql = "SELECT id FROM #__jcs_user_subscr WHERE gateway = '{$post['processor']}' AND gateway_id = '{$post['invoiceId']}'";
			$db->setQuery($sql);
			$res = $db->loadResult();
			if($res)
			{
				$sql = "UPDATE #__jcs_user_subscr SET published = 1 WHERE id = {$res}";
				$db->setQuery($sql);
				$db->query();
				
				if($params->get($post['processor'].'_errorlog', $default->get($post['processor'].'_errorlog')))
				{
					error_log("[Start get post]:  ".print_r($post, true)."\n\n", 3, JPATH_ROOT.DS.'plugins'.DS.'payment'.DS.'rbk_log.txt');
				}
				
				return null;
			}
			else
			{
				$order['pay']="success";
			}	
		}
		else
		{
			$order['pay'] = 'fail';
		}
		
		if($params->get($post['processor'].'_errorlog', $default->get($post['processor'].'_errorlog')))
		{
			error_log("[Start get post]:  ".print_r($post, true)."\n\n", 3, JPATH_ROOT.DS.'plugins'.DS.'payment'.DS.'rbk_log.txt');
		}
		
		return $order; 				
	}
		
	function onSendPayment(&$post) 
	{
	    if($post['processor'] != 'payrbk') 
	    {
	    	return false;
	    }
	    $db = JFactory::getDBO();
	    if($post['params'])
	    {
			$settings = new JParameter($post['params']);
	    }
	    else
	    {
			$settings = $this->params;
		}
   
		$amount = $post['order_amount'];
		$eshopid = $settings->get($post['processor']."_eshopid");
		$service = $settings->get($post['processor']."_shopname");
		$currency = $settings->get($post['processor']."_currency");
		$secret = $settings->get($post['processor']."_secret");
		$user = &JFactory::getUser();

		$SQL = "SELECT * FROM #__jcs_plans WHERE id={$post['order_id']}";
		$db->setQuery($SQL);
		$planname = $db->loadObject();

		$rbk = new rbk($eshopid,$post['order_id']);
		
		$rbk->setCurrency($currency);
		$rbk->setTotal($amount);
		$rbk->setServiceName($service."-".$planname->name);	
		$rbk->setOrderId($post['order_id']);
		$rbk->setEmail($user->email);
		$rbk->setUid($user->id);
		$rbk->setSecret($secret);
		$rbk->setRetURL(JURI::base().'index.php?option=com_jcs&view=jcs&layout=history&Itemid='.(JCS_HISTORY != '' ? JCS_HISTORY : JRequest::getInt('Itemid')), false);
		
		$form = $rbk->getForm();
			
		echo $form;
	}
	
}

class rbk
{
	var $eshopId;
	var $recipientAmount;
	var $recipientCurrency;
	var $orderId;		
	var $user_email;
	var $serviceName;
	var $retURL;
	var $secret;
	var $uid;
	var $sid;
		
	function rbk( $eshopId,$sid=1)
	{
		$this->eshopId    	= $eshopId;
		$this->recipientAmount	=0;
		$this->recipientCurrency= 'RUR';
		$this->orderId = "";
		$this->user_email        = 0;
		$this->serviceName    = "";
		$this->retURL  = "";
		$this->secret = "";
		$this->uid=0;
		$this->sid=$sid;
	}
		
	function seteshopId($eid)
	{
		$this->eshopId=$eid;
	}
	
	function setOrderId( $id )
	{
		$this->orderId = $id;
	}
	
	function setTotal( $total )
	{
		$this->recipientAmount = $total;
	}
		
	function setServiceName( $name )
	{
		$this->serviceName = $name;
	}
	
	function setCurrency( $curcode )
	{
		$this->recipientCurrency = $curcode;
	}

	function setEmail( $email )
	{
		$this->user_email = $email;
	}
	
	function setRetURL( $URL )
	{
		$this->retURL = $URL;
	}
	
	function setSecret( $secret )
	{
		$this->secret = $secret;
	}

	function setUid( $uid )
	{
		$this->uid = $uid;
	}
	
	function getForm()
	{
		$form = "<script type='text/javascript'>\r\n";
    	$form .= "<!--\r\n";
		$form .= "document.write(\"<div style='display:none;'>\");\r\n";
		$form .= "-->\r\n";
		$form .= "</script>\r\n";
		$form .= "<div style='float:right'>\r\n";
		$form .= "<FORM id='summary_form' action='https://rbkmoney.ru/acceptpurchase.aspx' method='POST'>\r\n";
		$form .= "<INPUT type='hidden' name='eshopId' value='$this->eshopId'>\r\n";
		$form .= "<INPUT type='hidden' name='recipientAmount' value='$this->recipientAmount'>\r\n";
		$form .= "<INPUT type='hidden' name='recipientCurrency' value='$this->recipientCurrency'>\r\n";
		$form .= "<INPUT type='hidden' name='orderId' value='$this->orderId'>\r\n";
		$form .= "<INPUT type='hidden' name='serviceName' value='$this->serviceName'>\r\n";
		$form .= "<INPUT type='hidden' name='successUrl' value='".$this->retURL."'>\r\n";
		$form .= "<INPUT type='hidden' name='failUrl' value='".$this->retURL."'>\r\n";
		$form .= "<INPUT type='hidden' name='user_email' value='$this->user_email'>\r\n";
		$form .= "<INPUT type='hidden' name='userField_1' value='$this->sid'>\r\n";
		$form .= "<INPUT type='hidden' name='userField_2' value='$this->uid'>\r\n";
		$form .= "</FORM>\r\n";
		$form .= "</div>\r\n";
		$form .= "<script type='text/javascript'>\r\n";
		$form .= "<!--\r\n";
		$form .= "document.write('</div>');\r\n";
		$form .= "document.getElementById('summary_form').submit();\r\n";
		$form .= "-->\r\n";
		$form .= "</script>\r\n";

		return $form;
	}
		
}

?>
